ImageMorph subclass: #GameImageMorph
	instanceVariableNames: 'imgsys'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Game'!

!GameImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/13/2015 21:59'!
gamemorph
	||
	^self! !

!GameImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/13/2015 22:01'!
initialize

	||
	imgsys := GameImgSys new.! !

!GameImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/13/2015 21:59'!
addMorphTo:aWindow
	||
	aWindow addMorph:self! !

!GameImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/13/2015 22:05'!
new
	||
	
	super initialize.
	self initialize.
	^self! !

!GameImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/13/2015 22:04'!
load: aFilename
	|png|
	
	png := imgsys load:aFilename.
	self new image:png.! !


GameImageMorph subclass: #EntityImageMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Game'!

!EntityImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 00:14'!
width
	||
	^ super extent x.! !

!EntityImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/13/2015 22:41'!
position: pos 

	||
	super position: pos.
	^self! !

!EntityImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 07:21'!
update: pos with: room

	||
	self position: pos.
	^self! !

!EntityImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 07:25'!
hitOn: player 

	||
	
	player hitpoints:1 negated.! !

!EntityImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 00:13'!
x:xx

	||
	super position: xx@(super position y).
	^self! !

!EntityImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 06:49'!
getUpdatedPositionWith: player

	||

	"Override this method for position updates of your entity"

	^ super position.
! !

!EntityImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 01:20'!
getUpdatedPosition

	||

	"Override this method for position updates of your entity"

	^ super position.
! !

!EntityImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 00:15'!
height
	||
	^ super extent y.! !

!EntityImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 00:12'!
x

	||
	super position x.
	^self! !

!EntityImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 00:16'!
width:w
	||
	^ super extent:w@(super extent y).! !

!EntityImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 00:13'!
y

	||
	super position y.
	^self! !

!EntityImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 00:14'!
y:yy

	||
	super position: (super position x)@yy.
	^self! !

!EntityImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 00:15'!
height:h
	||
	^ super extent:(super extent x)@h.! !

!EntityImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 02:11'!
update

	||
	
	^self! !


EntityImageMorph subclass: #PlayerImageMorph
	instanceVariableNames: 'hitpoints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Game'!

!PlayerImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 07:25'!
hitWith: aEntity 
	||
	
	aEntity hitOn: self.! !

!PlayerImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 00:17'!
load
	||
	self load:'player-static-down-32x32.png'! !

!PlayerImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 07:27'!
hitpoints
	||
	
	^ hitpoints! !

!PlayerImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 07:26'!
hitpoints: xx
	||
	
	hitpoints := hitpoints + xx.! !


Object subclass: #StateImageLibrary
	instanceVariableNames: 'list index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Game'!

!StateImageLibrary methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 01:25'!
add: o

	list add:o.! !

!StateImageLibrary methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 01:25'!
initialize

	list := LinkedList new.! !

!StateImageLibrary methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 01:27'!
get

	(index >= list size)ifTrue:[ index := 0. ].
	
	^ list at: index! !

!StateImageLibrary methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 01:27'!
get: i

	(i >= list size)ifTrue:[ index := 0. ].
	
	^ list at: i! !

!StateImageLibrary methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 01:24'!
at: i

	^ list at: i! !


Random subclass: #RNG
	instanceVariableNames: 'imgsys'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Game'!

GameImageMorph subclass: #RoomImageMorph
	instanceVariableNames: 'entities'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Game'!

!RoomImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 00:57'!
addEntity:aEntity 
	||

	entities add:aEntity.
	
	"subclassresponsibility"	
	"self load:'defaultroom.png'"
! !

!RoomImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 01:17'!
update: pos withdo: player

	| e |
	
	e := EntityImageMorph new.
	entities do:[ e | e update: (e position) with: self].! !

!RoomImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 00:56'!
load
	||

	entities := LinkedList new.
	
	"subclassresponsibility"	
	"self load:'defaultroom.png'"
! !

!RoomImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 07:23'!
update: pos with: player

	| index |
	index:=0.
	[ index < entities size ] whileTrue:[
		[(entities at: index) update: (entities at:index getUpdatedPositionWith: player) with: self] 
	ifFalse:

		"if false is returned the entity gets deleted from the entities list"	

		[entities remove: (entities at: index). 
		"hit player"
		player hitWith:(entities at: index).
		].]. 
	"self position:(self position + pos)"! !


RoomImageMorph subclass: #RoomFields
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Game'!

!RoomFields methodsFor: 'as yet unclassified' stamp: 'JC 8/13/2015 22:34'!
load
	||
	self load:'bg-1-320x200.png'! !


EntityImageMorph subclass: #EntityActing4WaysImageMorph
	instanceVariableNames: 'leftstateimagelibrary rightstateimagelibrary upstateimagelibrary downstateimagelibrary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Game'!

!EntityActing4WaysImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 06:28'!
addLeftImage: filename

	| png |
	png := imgsys load:filename.
	leftstateimagelibrary add: png.! !

!EntityActing4WaysImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 06:29'!
addRightImage: filename

	| png |
	png := imgsys load:filename.
	rightstateimagelibrary add: png.! !

!EntityActing4WaysImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 06:29'!
addUpImage: filename

	| png |
	png := imgsys load:filename.
	upstateimagelibrary add: png.! !

!EntityActing4WaysImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 06:29'!
addDownImage: filename

	| png |
	png := imgsys load:filename.
	downstateimagelibrary add: png.! !


EntityActing4WaysImageMorph subclass: #OctorImageMorph
	instanceVariableNames: 'rng olddirection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Game'!

!OctorImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 06:33'!
initialize

	||
	
	rng := RNG new.
	^ self.! !

!OctorImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 06:49'!
getUpdatedPositionWith: player
	
	| p r |
	""
	
	r := rng nextInt:50.
	
	(r = 50)ifTrue:[		
		r := rng nextInt:4.
		olddirection := r.
		
	 	(r = 1 and olddirection !!= 1) ifTrue:[
			p := self position.
			self position: p + (1@0).].
		(r = 2 and olddirection !!= 2) ifTrue:[
			p := self position.
			self position: p - (1@0).].
		(r = 3 and olddirection !!= 3) ifTrue:[
			p := self position.
			self position: p + (0@1).].
		(r = 4 and olddirection !!= 4) ifTrue:[
			p := self position.
			self position: p - (0@1).].
		].! !

!OctorImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 06:42'!
getUpdatedPosition
	
	| p r |
	""
	
	r := rng nextInt:50.
	
	(r = 50)ifTrue:[		
		r := rng nextInt:4.
		olddirection := r.
		
	 	(r = 1 and olddirection !!= 1) ifTrue:[
			p := self position.
			self position: p + (1@0).].
		(r = 2 and olddirection !!= 2) ifTrue:[
			p := self position.
			self position: p - (1@0).].
		(r = 3 and olddirection !!= 3) ifTrue:[
			p := self position.
			self position: p + (0@1).].
		(r = 4 and olddirection !!= 4) ifTrue:[
			p := self position.
			self position: p - (0@1).].
		].! !


Object subclass: #PlayExampleGame
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Game'!

!PlayExampleGame methodsFor: 'as yet unclassified' stamp: 'JC 8/13/2015 23:50'!
test
	|window|

	"To run :"
	"You just call 'PlayExampleGame new test.' in a Transcript window"
		
	window := GameWindow new.
	window initialize.
	
	window show:320@220.! !


EntityImageMorph subclass: #EntityMissileImageMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Game'!

!EntityMissileImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 07:22'!
getUpdatedPositionWith: player
	
	| px py x y pw ph |
	
	px := player position x.
	py := player position y.
	
	x := self position x.
	y := self position y.
	
 	pw := player width.
	ph := player height.
	
	[ x >= px and x <= px + pw and y >= py and y <= ph + py ]ifTrue:[^ false. "delete entity from list"].
	 ! !


SystemWindow subclass: #GameWindow
	instanceVariableNames: 'room playerimagemorph player process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Game'!

!GameWindow methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 00:53'!
show:aExtent
	||
	self openInWorldExtent:aExtent.
	
	process := Process new initialize run.
	process completeStep:(self update).! !

!GameWindow methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 00:50'!
update
	||
	room update:0@0 with:player.
	^true! !

!GameWindow methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 00:33'!
initialize
	||
	super initialize.
	room := RoomFields new.
	room load.
	room position: 0@20.
	room addMorphTo:self.
	
	player := PlayerImageMorph new.
	player load.
	player position: 120@100.
	player addMorphTo:self.! !

!GameWindow methodsFor: 'as yet unclassified' stamp: 'JC 8/13/2015 22:08'!
new
	||
	super new.
	^self! !

!GameWindow methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 00:33'!
handleKeystroke: anEvent
	|keyValue|
	keyValue := anEvent keyValue.
	keyValue = 30 "up arrow"
	ifTrue:[
		"playerimagemorph position y <= (self position y + 21) ifFalse:[
			playerimagemorph position:playerimagemorph position - (0@1)]."
			room update: (0@1) with: player. 
		].
	
	keyValue = 31 "down arrow"
	ifTrue:[
	"	playerimagemorph position y >= (self position y + (219-playerimagemorph width)) ifFalse:[
			playerimagemorph position:playerimagemorph position + (0@1)]."
		
			room update: (0@1) negated with: player.
		].
	
	keyValue = 29 "right arrow"
	ifTrue:[
	"	playerimagemorph position x >= (self position x + 319) ifFalse:[
			playerimagemorph position:playerimagemorph position + (1@0)]."
			room update:(1@0) negated with: player.
		].
	
	keyValue = 28 "left arrow"
	ifTrue:[
	"	playerimagemorph position x <= (self position x + 1) ifFalse:[
			playerimagemorph position:playerimagemorph position - (1@0)]."
			room update:(1@0) with:player.
		
		].! !


EntityActing4WaysImageMorph subclass: #SeekerImageMorph
	instanceVariableNames: 'rng olddirection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Game'!

!SeekerImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 06:46'!
getUpdatedPosition

	||
	
	! !

!SeekerImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 06:54'!
getUpdatedPositionWith: player

	| px py x y |
	
	px := player position x.
	py := player position y.
	
	x := self position x.
	y := self position y.
	
	[ px <= x ]ifTrue:[ self x: (x-1). ].
	[ px >= x ]ifTrue:[ self x: (x+1). ].
	[ py <= y ]ifTrue:[ self y: (y-1). ].
	[ py >= y ]ifTrue:[ self y: (y+1). ].
	
	! !

!SeekerImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 06:46'!
initialize

	||
	
	rng := RNG new.
	^ self.! !


LinkedList subclass: #ObserverList
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Game'!

!ObserverList methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 02:08'!
initialize

	||
	
	^self! !


EntityImageMorph subclass: #EntityActingImageMorph
	instanceVariableNames: 'stateimagelibrary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Game'!

!EntityActingImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 01:34'!
addImage: filename

	| png |
	png := imgsys load:filename.
	stateimagelibrary add: png.! !

!EntityActingImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 01:29'!
initialize
	super initialize.
	stateimagelibrary := StateImageLibrary new.! !

!EntityActingImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 01:35'!
addImage: filename with: gameimgsys

	| png |
	png := gameimgsys load: filename
	stateimagelibrary add: png.! !

!EntityActingImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 01:37'!
getUpdatedPosition
	
	| p |
	"example code"
	p := self position.
	self position: p + (0@0).! !


EntityImageMorph subclass: #EntityActingObserverImageMorph
	instanceVariableNames: 'observerlist'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Game'!

!EntityActingObserverImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 02:08'!
attachEntity: aEntity

	observerlist add: aEntity.! !

!EntityActingObserverImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 02:09'!
detachEntity: aEntity

	observerlist remove: aEntity.! !

!EntityActingObserverImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 02:11'!
notify

	| o |
	
	observerlist do: [ o | o update. ]
	! !

!EntityActingObserverImageMorph methodsFor: 'as yet unclassified' stamp: 'JC 8/14/2015 02:07'!
initialize

	observerlist := ObserverList new initialize.
	^self! !


Object subclass: #GameImgSys
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Games-Game'!

!GameImgSys methodsFor: 'as yet unclassified' stamp: 'JC 8/13/2015 22:28'!
load: aFilename
	|png|
	png := PNGReadWriter formFromFileNamed: aFilename.
	^ png! !

!GameImgSys methodsFor: 'as yet unclassified' stamp: 'JC 8/13/2015 22:01'!
new
	||
	super new.
	^ self.! !
